<link rel="import" href="/bower_components/polymer/polymer-element.html">
<link rel="import" href="../l1page-theme/l1page-theme.html">
<link rel="import" href="../toast-manager/when-life-gives-you-lemons-make-toast.html">
<link rel="import" href="subsystem-app.html">

<!--
`<subsystem-details>` is not documented properly yet
-->
<dom-module id="subsystem-details">
  <template>
    <link rel="stylesheet" href="subsystem-details.css?__inline=true">
    <style include="l1page-theme"></style>

    <app-route route={{route}} pattern="/:selectedSubsystem" data={{urlData}}></app-route>

    <header>
      <h1>[[urlData.selectedSubsystem]]</h1>
      <p>[[_inRunText(urlData.selectedSubsystem, includedSubsystems)]]</p>
      <p severity$=[[_applicationStatus]]>[[_applicationSummary(_applicationStatus)]]</p>
      <p severity$=[[_alarmStatus]]>[[_alarmSummary(_subsystem)]]</p>
      <p severity$=[[_operationStatus]]>[[_operationSummary(_subsystem)]]</p>
      <dom-if if="[[_showAppsButton(_subsystem)]]">
        <template>
          <a class="anchor" href="[[_getAppsLink(_subsystem)]]" target="_blank"><paper-button raised class="green">Go to application</paper-button></a>
        </template>
      </dom-if>
    </header>

    <dom-if if="[[_nothingToSee(_apps.length, _subsystem.actions)]]">
      <template>
        <section empty>
          <img src="/images/empty_state.png" alt="state empty">
          <h1>Nothing to see here</h1>
          <p>[[urlData.selectedSubsystem]] is not reporting any data to L1Page</p>
        </section>
      </template>
    </dom-if>

    <!-- customiazed treatments with different cells -->
    <dom-if if="[[_apps.length]]">
      <template>
        <section apps>
          <!--sort put TSTORE at last-->
          <dom-repeat items="[[_apps]]" as=app sort="_sort">
            <template>
                <!-- only keep the apps with operations or from the defined subset -->
                <dom-if if="[[_displayApp(app, ['TSTORE', 'TRG_B2IN-EVENTING', 'TRG_SLASH', 'API'])]]">
                    <template>
                        <subsystem-app app-data=[[app]]></subsystem-app>
                    </template>
            </template>
          </dom-repeat>
        </section>
      </template>
    </dom-if>

    <dom-if if=[[_subsystem.actions.length]]>
      <template>
        <section process-control>
            <h1>Process Control</h1>
            <div>
            <dom-repeat items="[[_subsystem.actions]]" as=action>
              <template>
                <paper-button warning$=[[_isDangerous(action)]] secondary$=[[!_isDangerous(action)]] raised on-click=_executeAction disabled=[[_actionBusy]]>[[action]]</paper-button>
              </template>
            </dom-repeat>
            <img src="/images/hourglass_color.gif" alt="busy..." hide$=[[!_actionBusy]]>
            </div>
        </section>
        <pre id="process_result"></pre>
      </template>
    </dom-if>

    <slot></slot>
  </template>
</dom-module>

<script src="subsystem-details.js?__inline=true"></script>
